/*
 * Created on Oct 17, 2003
 *
 */
package com.punosmusic.larrybirthday;

import com.softsynth.jmsl.MusicShape;

/**
 * Translate a -1, 0, 1 contour to a String of D, S, U
 * 
 * @author Nick Didkovsky, (c) 2003 Nick Didkovsky, didkovn@mail.rockefeller.edu, All rights reserved
 * 
 */
public class ContourToString {

	private static String[] values = { "D", "S", "U" };

	/** @return "SUD" representation of MusicShape containing -1, 0, 1 */
	public static String translate(MusicShape contourShape) {
		StringBuffer buf = new StringBuffer();
		for (int d = 0; d < contourShape.dimension(); d++) {
			for (int i = 0; i < contourShape.size(); i++) {
				buf.append(values[(int) contourShape.get(i, d) + 1]);
			}
			buf.append("\n");
		}
		return buf.toString();
	}

	public static void main(String[] args) {
		MusicShape s = new MusicShape(1);
		s.add(10);
		s.add(10);
		s.add(4);
		s.add(13);
		MusicShape contourShape = CombinatorialContourAnalyzer.getOneDimensionalContour(s, 0);
		contourShape.print();
		System.out.println(ContourToString.translate(contourShape));
	}
}
