/*
 * Created on Oct 17, 2003
 *
 */
package com.punosmusic.larrybirthday;

/**
 * Input is two Strings 
 * Output is String of length == shorter string
 * 
 * Equal characters are revealed, and unequal characters are shown with "-"
 * (ie they are "screened" against each other)
 * 
 * @author Nick Didkovsky, (c) 2003 Nick Didkovsky, didkovn@mail.rockefeller.edu, All rights reserved
 *
 */
public class StringScreen {

	private int numDifferent;

	public String compare(String s1, String s2) {
		StringBuffer buf = new StringBuffer();
		numDifferent = 0;
		for (int i = 0; i < Math.min(s1.length(), s2.length()); i++) {
			if (s1.charAt(i) == s2.charAt(i)) {
				buf.append(s1.charAt(i));
			}
			else {
				buf.append("-");
				numDifferent++;
			}
		}
		return buf.toString();
	}

	/** Only valid after compare() is called */
	public int getNumDifferent() {
		return this.numDifferent;
	}

	public static void main(String[] args) {
		System.out.println(new StringScreen().compare("SU\nSU\nDU", "SU\nUU\nDS"));
	}
}
